Subject: Re: Interpretation problems - perceived conflict between RFC 2141 and RFC 2396

From: Ron Daniel <[email-masked]>
Date: Wed, 2 Jun 1999 08:38:38 -0700

On the use of '/' in URNs...

Recall that 2141 says that people SHOULD NOT use unencoded
forward slashes in URNs. This was because of the interaction with
the notion of relative URNs. However, that document deliberately
says SHOULD NOT, not MUST NOT. So, a URN can contain unencoded
forward slashes and still conform to the syntax of RFC 2141.
However, if it does it is probably broken in terms of uniqueness
since people can come in and try to make other URNs relative to
it. Browser software might build a real URN from the relative
one, but that is only an implementation accident since there is
no standard for relative URNs at this time, nor is there likely
to be one in the foreseeable future.

regards,
Ron

> -----Original Message-----
> From: Leslie Daigle [SMTP:[email-masked]]
> Sent: Wednesday, June 02, 1999 6:30 AM
> To:   [email-masked]
> Subject:      Re: Interpretation problems - perceived conflict between
> RFC 2141 and RFC 2396
>
> Howdy,
>
> Thanks for forwarding the questions.
>
> Didier PH Martin wrote:
> > *RFC 2141 states that the forward-slash (and other reserved)
> character
> > should not be used in unescaped form, as its "applicability" is (or
> was at
> > time of writing, 5/97) still open to debate.
> >
> > *RFC 2396, on the other hand, states that forward-slash (and other
> reserved)
> > character should not be used in unescaped form IF "the data...would
> conflict
> > with the reserved purpose". This seems to imply that it's ok to use
> "/"
> > unescaped if it denotes a hierarchical namespace.
>
> Actually, I read the words to the contrary.  I read these words to
> say that unescaped "/" should be interpreted by the rules of hierarchy
> laid out in 2396, and any other expected interpretation requires
> the character to be escaped.
>
> 2396 defines a particular mechanism for interpreting and manipulating
> hierarchical structures of URIs -- denoted by the use of the forward
> slash.  This includes the ability to make relative references, etc,
> that we were never able to reconcile with the notion of providing
> fixed, persistent references (URNs).
>
> Rather than try to effect changes to that interpretation of "/" in
> URIs, or subject URNs to all existing URI rules for handling
> that hierarchy, we decided to abstain from the use of the character.
>
> Note that this does not mean namespaces cannot use "/" to denote
> hierarchy -- if it is escaped, it can be used for hierarchy as
> it is understood local to a particular namespace (i.e., browsers
> and editors will not attempt to create or interpret relative URIs
> of them).
>
> > *RFC 2396 APPEARS to state that an "authority" must be preceded by
> > double-forward-slash. It is not totally clear to me whether this
> applies to
> > the NID component of a URN.
>
> Again, this is "authority" as it is defined by the URI syntax, subject
> to the particular interpretation as laid out in 2396.  There are
> other URI schemes that do not have an authority component preceded
> by "//".
>
> > First of all, I would be interested in opinions as to the above
> statements.
>
> See above.
>
> > Secondly, I would be interested in opinions as to the advisability
> of going
> > ahead and using unencoded forward-slashes to denote hierarchy within
> a URN.
>
> Don't.
>
> :->
>
> More seriously, look a little more closely at the problem, and I
> think you'll see the distinction we're trying to draw.
>
> > I need to denote such hierarchy, and it seems hard to believe that
> > forward-slash wouldn't be defined to denote such hierarchy. Thus
> encoding it
> > seems like a waste of time, effort, and an unnecessary loss of
> readability.
>
> a) don't forget that URNs are not primarily targetted at being
>    human-readable
> b) is the hierarchy you are looking for really all the bells &
>    whistles of relative URIs as found in 2369, in which case you
>    may not be after a URN afterall.  You may want the resolution
>    mechanisms laid out in, for instance, the NAPTR RDS, but those
>    are already described in generic terms as being applicable to
>    all URIs, not just URNs.
>
> Leslie.
>
> --
>
> ----------------------------------------------------------------------
> --
>
> "My cat has all the answers.  But she claims     Leslie Daigle
>    she doesn't know the questions."
> [email-masked]
>
> ----------------------------------------------------------------------
> --

---

From: Ron Daniel <[email-masked]>
Date: Wed, 2 Jun 1999 08:38:38 -0700

regards,
Ron